diff -ruN qmail-1.03-orig/hier.c qmail-1.03-ldap-20060201-orig/hier.c
--- qmail-1.03-orig/hier.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/hier.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,9 +1,21 @@
 #include "auto_qmail.h"
 #include "auto_split.h"
 #include "auto_uids.h"
+#include "auto_userl.h"
 #include "fmt.h"
 #include "fifo.h"
 
+extern void c(const char *, const char *, const char *, int, int, int);
+extern void C(const char *, const char *, const char *, const char *,
+ int, int, int);
+extern void d(const char *, const char *, int, int, int);
+extern void h(const char *, int, int, int);
+extern void l(const char *, const char *, const char *, const char *,
+ int, int, int);
+extern void p(const char *, const char *, int, int, int);
+extern void z(const char *, const char *, int, int, int, int);
+
+
 char buf[100 + FMT_ULONG];
 
 void dsplit(base,uid,mode)
@@ -34,8 +46,46 @@
   d(auto_qmail,"control",auto_uido,auto_gidq,0755);
   d(auto_qmail,"users",auto_uido,auto_gidq,0755);
   d(auto_qmail,"bin",auto_uido,auto_gidq,0755);
-  d(auto_qmail,"boot",auto_uido,auto_gidq,0755);
   d(auto_qmail,"doc",auto_uido,auto_gidq,0755);
+
+  /* boot restructured for daemontools */
+  d(auto_qmail,"boot",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail/env",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail/log",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-smtpd",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-smtpd/env",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-smtpd/log",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-qmqpd",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-qmqpd/env",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-qmqpd/log",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-pop3d",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-pop3d/env",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-pop3d/log",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-imapd",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-imapd/env",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-imapd/log",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-pop3d-ssl",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-pop3d-ssl/env",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-pop3d-ssl/log",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-imapd-ssl",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-imapd-ssl/env",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-imapd-ssl/log",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-pbsdbd",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-pbsdbd/env",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-pbsdbd/log",auto_uido,auto_gidq,0755);
+
+  /* logging restructured for daemontools */
+  d(auto_qmail,"log",auto_uidl,auto_gidq,0755);
+  d(auto_qmail,"log/qmail",auto_uidl,auto_gidq,0755);
+  d(auto_qmail,"log/qmail-smtpd",auto_uidl,auto_gidq,0755);
+  d(auto_qmail,"log/qmail-qmqpd",auto_uidl,auto_gidq,0755);
+  d(auto_qmail,"log/qmail-pop3d",auto_uidl,auto_gidq,0755);
+  d(auto_qmail,"log/qmail-imapd",auto_uidl,auto_gidq,0755);
+  d(auto_qmail,"log/qmail-pop3d-ssl",auto_uidl,auto_gidq,0755);
+  d(auto_qmail,"log/qmail-imapd-ssl",auto_uidl,auto_gidq,0755);
+  d(auto_qmail,"log/qmail-pbsdbd",auto_uidl,auto_gidq,0755);
+
   d(auto_qmail,"man",auto_uido,auto_gidq,0755);
   d(auto_qmail,"man/cat1",auto_uido,auto_gidq,0755);
   d(auto_qmail,"man/cat5",auto_uido,auto_gidq,0755);
@@ -50,30 +100,57 @@
 
   d(auto_qmail,"queue",auto_uidq,auto_gidq,0750);
   d(auto_qmail,"queue/pid",auto_uidq,auto_gidq,0700);
+#ifndef BIGTODO
   d(auto_qmail,"queue/intd",auto_uidq,auto_gidq,0700);
   d(auto_qmail,"queue/todo",auto_uidq,auto_gidq,0750);
+#endif
   d(auto_qmail,"queue/bounce",auto_uids,auto_gidq,0700);
 
   dsplit("queue/mess",auto_uidq,0750);
   dsplit("queue/info",auto_uids,0700);
   dsplit("queue/local",auto_uids,0700);
   dsplit("queue/remote",auto_uids,0700);
+#ifdef BIGTODO
+  dsplit("queue/intd",auto_uidq,0700);
+  dsplit("queue/todo",auto_uidq,0750);
+#endif
 
   d(auto_qmail,"queue/lock",auto_uidq,auto_gidq,0750);
   z(auto_qmail,"queue/lock/tcpto",1024,auto_uidr,auto_gidq,0644);
   z(auto_qmail,"queue/lock/sendmutex",0,auto_uids,auto_gidq,0600);
   p(auto_qmail,"queue/lock/trigger",auto_uids,auto_gidq,0622);
 
-  c(auto_qmail,"boot","home",auto_uido,auto_gidq,0755);
-  c(auto_qmail,"boot","home+df",auto_uido,auto_gidq,0755);
-  c(auto_qmail,"boot","proc",auto_uido,auto_gidq,0755);
-  c(auto_qmail,"boot","proc+df",auto_uido,auto_gidq,0755);
-  c(auto_qmail,"boot","binm1",auto_uido,auto_gidq,0755);
-  c(auto_qmail,"boot","binm1+df",auto_uido,auto_gidq,0755);
-  c(auto_qmail,"boot","binm2",auto_uido,auto_gidq,0755);
-  c(auto_qmail,"boot","binm2+df",auto_uido,auto_gidq,0755);
-  c(auto_qmail,"boot","binm3",auto_uido,auto_gidq,0755);
-  c(auto_qmail,"boot","binm3+df",auto_uido,auto_gidq,0755);
+  /* rules file for tcpserver */
+  C(auto_qmail,"control","qmail-smtpd.rules","qmail-smtpd.rules",auto_uido,auto_gidq,0644);
+  C(auto_qmail,"control","qmail-qmqpd.rules","qmail-qmqpd.rules",auto_uido,auto_gidq,0644);
+  C(auto_qmail,"control","qmail-pop3d.rules","qmail-pop3d.rules",auto_uido,auto_gidq,0644);
+  C(auto_qmail,"control","qmail-imapd.rules","qmail-imapd.rules",auto_uido,auto_gidq,0644);
+  
+  /* Makefile for cdb creation */
+  C(auto_qmail,"control","Makefile","Makefile.cdb-p",auto_uido,auto_gidq,0644);
+  
+  /* signature file for qmail-smtpd ecexcheck freature */
+  C(auto_qmail,"control","signatures","signatures",auto_uido,auto_gidq,0644);
+
+  /* run files for boot/supervise scripts */
+  C(auto_qmail,"boot/qmail", "run", "qmail.run",auto_uido,auto_gidq,0755);
+  C(auto_qmail,"boot/qmail-smtpd", "run", "qmail-smtpd.run",auto_uido,auto_gidq,0755);
+  C(auto_qmail,"boot/qmail-qmqpd", "run", "qmail-qmqpd.run",auto_uido,auto_gidq,0755);
+  C(auto_qmail,"boot/qmail-pop3d", "run", "qmail-pop3d.run",auto_uido,auto_gidq,0755);
+  C(auto_qmail,"boot/qmail-imapd", "run", "qmail-imapd.run",auto_uido,auto_gidq,0755);
+  C(auto_qmail,"boot/qmail-pop3d-ssl", "run", "qmail-pop3d-ssl.run",auto_uido,auto_gidq,0755);
+  C(auto_qmail,"boot/qmail-imapd-ssl", "run", "qmail-imapd-ssl.run",auto_uido,auto_gidq,0755);
+  C(auto_qmail,"boot/qmail-pbsdbd", "run", "qmail-pbsdbd.run",auto_uido,auto_gidq,0755);
+
+  /* run files for logging process */
+  l(auto_qmail,"boot/qmail/log","log/qmail",auto_userl,auto_uido,auto_gidq,0755);
+  l(auto_qmail,"boot/qmail-smtpd/log","log/qmail-smtpd",auto_userl,auto_uido,auto_gidq,0755);
+  l(auto_qmail,"boot/qmail-qmqpd/log","log/qmail-qmqpd",auto_userl,auto_uido,auto_gidq,0755);
+  l(auto_qmail,"boot/qmail-pop3d/log","log/qmail-pop3d",auto_userl,auto_uido,auto_gidq,0755);
+  l(auto_qmail,"boot/qmail-imapd/log","log/qmail-imapd",auto_userl,auto_uido,auto_gidq,0755);
+  l(auto_qmail,"boot/qmail-pop3d-ssl/log","log/qmail-pop3d-ssl",auto_userl,auto_uido,auto_gidq,0755);
+  l(auto_qmail,"boot/qmail-imapd-ssl/log","log/qmail-imapd-ssl",auto_userl,auto_uido,auto_gidq,0755);
+  l(auto_qmail,"boot/qmail-pbsdbd/log","log/qmail-pbsdbd",auto_userl,auto_uido,auto_gidq,0755);
 
   c(auto_qmail,"doc","FAQ",auto_uido,auto_gidq,0644);
   c(auto_qmail,"doc","UPGRADE",auto_uido,auto_gidq,0644);
@@ -98,6 +175,13 @@
   c(auto_qmail,"doc","PIC.relaybad",auto_uido,auto_gidq,0644);
   c(auto_qmail,"doc","PIC.relaygood",auto_uido,auto_gidq,0644);
   c(auto_qmail,"doc","PIC.rem2local",auto_uido,auto_gidq,0644);
+  c(auto_qmail,"doc","QLDAPGROUP",auto_uido,auto_gidq,0644);
+  c(auto_qmail,"doc","QLDAPINSTALL",auto_uido,auto_gidq,0644);
+  c(auto_qmail,"doc","QLDAPNEWS",auto_uido,auto_gidq,0644);
+  c(auto_qmail,"doc","QLDAPTODO",auto_uido,auto_gidq,0644);
+  c(auto_qmail,"doc","QLDAPPICTURE",auto_uido,auto_gidq,0644);
+  c(auto_qmail,"doc","EXTTODO",auto_uido,auto_gidq,0644);
+  c(auto_qmail,"doc","POPBEFORESMTP",auto_uido,auto_gidq,0644);
 
   c(auto_qmail,"bin","qmail-queue",auto_uidq,auto_gidq,04711);
   c(auto_qmail,"bin","qmail-lspawn",auto_uido,auto_gidq,0700);
@@ -108,6 +192,9 @@
   c(auto_qmail,"bin","qmail-rspawn",auto_uido,auto_gidq,0711);
   c(auto_qmail,"bin","qmail-clean",auto_uido,auto_gidq,0711);
   c(auto_qmail,"bin","qmail-send",auto_uido,auto_gidq,0711);
+#ifdef EXTERNAL_TODO
+  c(auto_qmail,"bin","qmail-todo",auto_uido,auto_gidq,0711);
+#endif
   c(auto_qmail,"bin","splogger",auto_uido,auto_gidq,0711);
   c(auto_qmail,"bin","qmail-newu",auto_uido,auto_gidq,0700);
   c(auto_qmail,"bin","qmail-newmrh",auto_uido,auto_gidq,0700);
@@ -135,6 +222,7 @@
   c(auto_qmail,"bin","forward",auto_uido,auto_gidq,0755);
   c(auto_qmail,"bin","preline",auto_uido,auto_gidq,0755);
   c(auto_qmail,"bin","condredirect",auto_uido,auto_gidq,0755);
+  c(auto_qmail,"bin","condwrite",auto_uido,auto_gidq,0755);
   c(auto_qmail,"bin","bouncesaying",auto_uido,auto_gidq,0755);
   c(auto_qmail,"bin","except",auto_uido,auto_gidq,0755);
   c(auto_qmail,"bin","maildirmake",auto_uido,auto_gidq,0755);
@@ -143,6 +231,21 @@
   c(auto_qmail,"bin","qail",auto_uido,auto_gidq,0755);
   c(auto_qmail,"bin","elq",auto_uido,auto_gidq,0755);
   c(auto_qmail,"bin","pinq",auto_uido,auto_gidq,0755);
+  c(auto_qmail,"bin","qmail-reply",auto_uido,auto_gidq,0755);
+  c(auto_qmail,"bin","qmail-quotawarn",auto_uido,auto_gidq,0755);
+  c(auto_qmail,"bin","auth_pop",auto_uido,auto_gidq,0700);
+  c(auto_qmail,"bin","auth_imap",auto_uido,auto_gidq,0700);
+  c(auto_qmail,"bin","auth_smtp",auto_uido,auto_gidq,0755);
+  c(auto_qmail,"bin","qmail-verify",auto_uido,auto_gidq,0755);
+  c(auto_qmail,"bin","qmail-ldaplookup",auto_uido,0,0750);
+  c(auto_qmail,"bin","qmail-cdb",auto_uido,auto_gidq,0700);
+  c(auto_qmail,"bin","digest",auto_uido,auto_gidq,0755);
+  c(auto_qmail,"bin","pbsadd",auto_uido,auto_gidq,0755);
+  c(auto_qmail,"bin","pbscheck",auto_uido,auto_gidq,0755);
+  c(auto_qmail,"bin","pbsdbd",auto_uido,auto_gidq,0755);
+  c(auto_qmail,"bin","qmail-forward",auto_uido,auto_gidq,0755);
+  c(auto_qmail,"bin","qmail-secretary",auto_uido,auto_gidq,0755);
+  c(auto_qmail,"bin","qmail-group",auto_uido,auto_gidq,0755);
 
   c(auto_qmail,"man/man5","addresses.5",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/cat5","addresses.0",auto_uido,auto_gidq,0644);
diff -ruN qmail-1.03-orig/hostname.c qmail-1.03-ldap-20060201-orig/hostname.c
--- qmail-1.03-orig/hostname.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/hostname.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,3 +1,4 @@
+#include <unistd.h>
 #include "substdio.h"
 #include "subfd.h"
 #include "readwrite.h"
@@ -5,7 +6,7 @@
 
 char host[256];
 
-void main()
+int main()
 {
  host[0] = 0; /* sigh */
  gethostname(host,sizeof(host));
@@ -13,5 +14,5 @@
  substdio_puts(subfdoutsmall,host);
  substdio_puts(subfdoutsmall,"\n");
  substdio_flush(subfdoutsmall);
- _exit(0);
+ return 0;
 }
diff -ruN qmail-1.03-orig/idedit.c qmail-1.03-ldap-20060201-orig/idedit.c
--- qmail-1.03-orig/idedit.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/idedit.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,6 +1,7 @@
 #include <sys/types.h>
 #include <pwd.h>
 #include <grp.h>
+#include <unistd.h>
 #include "readwrite.h"
 #include "exit.h"
 #include "scan.h"
@@ -9,6 +10,7 @@
 #include "open.h"
 #include "seek.h"
 #include "fork.h"
+#include "wait.h"
 
 #define FATAL "idedit: fatal: "
 #define WARNING "idedit: warning: "
@@ -67,7 +69,7 @@
   pw = getpwnam(account);
 
   if (!pw && group) {
-    args[0] = "add-account";
+    args[0] = (char *)"add-account";
     args[1] = account;
     args[2] = group;
     args[3] = home;
@@ -101,7 +103,7 @@
   gr = getgrnam(group);
 
   if (!gr) {
-    args[0] = "add-group";
+    args[0] = (char *)"add-group";
     args[1] = group;
     args[2] = 0;
     run();
@@ -120,7 +122,7 @@
     strerr_die3x(111,FATAL,"excessively large gid for ",group);
 }
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -143,5 +145,5 @@
   u("qmailr","qmail","/var/qmail",argv[26],argv[27],argv[28],argv[29]);
   u("qmails","qmail","/var/qmail",argv[30],argv[31],argv[32],argv[33]);
 
-  _exit(0);
+  return 0;
 }
diff -ruN qmail-1.03-orig/install-big.c qmail-1.03-ldap-20060201-orig/install-big.c
--- qmail-1.03-orig/install-big.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/install-big.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,11 +1,22 @@
 #include "auto_qmail.h"
 #include "auto_split.h"
 #include "auto_uids.h"
+#include "auto_userl.h"
 #include "fmt.h"
 #include "fifo.h"
 
 char buf[100 + FMT_ULONG];
 
+extern void c(const char *, const char *, const char *, int, int, int);
+extern void C(const char *, const char *, const char *, const char *,
+ int, int, int);
+extern void d(const char *, const char *, int, int, int);
+extern void h(const char *, int, int, int);
+extern void l(const char *, const char *, const char *, const char *,
+ int, int, int);
+extern void p(const char *, const char *, int, int, int);
+extern void z(const char *, const char *, int, int, int, int);
+
 void dsplit(base,uid,mode)
 char *base; /* must be under 100 bytes */
 int uid;
@@ -35,6 +46,45 @@
   d(auto_qmail,"users",auto_uido,auto_gidq,0755);
   d(auto_qmail,"bin",auto_uido,auto_gidq,0755);
   d(auto_qmail,"boot",auto_uido,auto_gidq,0755);
+
+  /* boot restructured for daemontools */
+  d(auto_qmail,"boot",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail/env",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail/log",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-smtpd",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-smtpd/env",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-smtpd/log",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-qmqpd",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-qmqpd/env",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-qmqpd/log",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-pop3d",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-pop3d/env",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-pop3d/log",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-imapd",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-imapd/env",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-imapd/log",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-pop3d-ssl",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-pop3d-ssl/env",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-pop3d-ssl/log",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-imapd-ssl",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-imapd-ssl/env",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-imapd-ssl/log",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-pbsdbd",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-pbsdbd/env",auto_uido,auto_gidq,0755);
+  d(auto_qmail,"boot/qmail-pbsdbd/log",auto_uido,auto_gidq,0755);
+
+  /* logging restructured for daemontools */
+  d(auto_qmail,"log",auto_uidl,auto_gidq,0755);
+  d(auto_qmail,"log/qmail",auto_uidl,auto_gidq,0755);
+  d(auto_qmail,"log/qmail-smtpd",auto_uidl,auto_gidq,0755);
+  d(auto_qmail,"log/qmail-qmqpd",auto_uidl,auto_gidq,0755);
+  d(auto_qmail,"log/qmail-pop3d",auto_uidl,auto_gidq,0755);
+  d(auto_qmail,"log/qmail-imapd",auto_uidl,auto_gidq,0755);
+  d(auto_qmail,"log/qmail-pop3d-ssl",auto_uidl,auto_gidq,0755);
+  d(auto_qmail,"log/qmail-imapd-ssl",auto_uidl,auto_gidq,0755);
+  d(auto_qmail,"log/qmail-pbsdbd",auto_uidl,auto_gidq,0755);
+
   d(auto_qmail,"doc",auto_uido,auto_gidq,0755);
   d(auto_qmail,"man",auto_uido,auto_gidq,0755);
   d(auto_qmail,"man/cat1",auto_uido,auto_gidq,0755);
@@ -50,30 +100,57 @@
 
   d(auto_qmail,"queue",auto_uidq,auto_gidq,0750);
   d(auto_qmail,"queue/pid",auto_uidq,auto_gidq,0700);
+#ifndef BIGTODO
   d(auto_qmail,"queue/intd",auto_uidq,auto_gidq,0700);
   d(auto_qmail,"queue/todo",auto_uidq,auto_gidq,0750);
+#endif
   d(auto_qmail,"queue/bounce",auto_uids,auto_gidq,0700);
 
   dsplit("queue/mess",auto_uidq,0750);
   dsplit("queue/info",auto_uids,0700);
   dsplit("queue/local",auto_uids,0700);
   dsplit("queue/remote",auto_uids,0700);
+#ifdef BIGTODO
+  dsplit("queue/intd",auto_uidq,0700);
+  dsplit("queue/todo",auto_uidq,0750);
+#endif
 
   d(auto_qmail,"queue/lock",auto_uidq,auto_gidq,0750);
   z(auto_qmail,"queue/lock/tcpto",1024,auto_uidr,auto_gidq,0644);
   z(auto_qmail,"queue/lock/sendmutex",0,auto_uids,auto_gidq,0600);
   p(auto_qmail,"queue/lock/trigger",auto_uids,auto_gidq,0622);
 
-  c(auto_qmail,"boot","home",auto_uido,auto_gidq,0755);
-  c(auto_qmail,"boot","home+df",auto_uido,auto_gidq,0755);
-  c(auto_qmail,"boot","proc",auto_uido,auto_gidq,0755);
-  c(auto_qmail,"boot","proc+df",auto_uido,auto_gidq,0755);
-  c(auto_qmail,"boot","binm1",auto_uido,auto_gidq,0755);
-  c(auto_qmail,"boot","binm1+df",auto_uido,auto_gidq,0755);
-  c(auto_qmail,"boot","binm2",auto_uido,auto_gidq,0755);
-  c(auto_qmail,"boot","binm2+df",auto_uido,auto_gidq,0755);
-  c(auto_qmail,"boot","binm3",auto_uido,auto_gidq,0755);
-  c(auto_qmail,"boot","binm3+df",auto_uido,auto_gidq,0755);
+  /* rules file for tcpserver */
+  C(auto_qmail,"control","qmail-smtpd.rules","qmail-smtpd.rules",auto_uido,auto_gidq,0644);
+  C(auto_qmail,"control","qmail-qmqpd.rules","qmail-qmqpd.rules",auto_uido,auto_gidq,0644);
+  C(auto_qmail,"control","qmail-pop3d.rules","qmail-pop3d.rules",auto_uido,auto_gidq,0644);
+  C(auto_qmail,"control","qmail-imapd.rules","qmail-imapd.rules",auto_uido,auto_gidq,0644);
+  
+  /* Makefile for cdb creation */
+  C(auto_qmail,"control","Makefile","Makefile.cdb-p",auto_uido,auto_gidq,0644);
+  
+  /* signature file for qmail-smtpd ecexcheck freature */
+  C(auto_qmail,"control","signatures","signatures",auto_uido,auto_gidq,0644);
+
+  /* run files for boot/supervise scripts */
+  C(auto_qmail,"boot/qmail", "run", "qmail.run",auto_uido,auto_gidq,0755);
+  C(auto_qmail,"boot/qmail-smtpd", "run", "qmail-smtpd.run",auto_uido,auto_gidq,0755);
+  C(auto_qmail,"boot/qmail-qmqpd", "run", "qmail-qmqpd.run",auto_uido,auto_gidq,0755);
+  C(auto_qmail,"boot/qmail-pop3d", "run", "qmail-pop3d.run",auto_uido,auto_gidq,0755);
+  C(auto_qmail,"boot/qmail-imapd", "run", "qmail-imapd.run",auto_uido,auto_gidq,0755);
+  C(auto_qmail,"boot/qmail-pop3d-ssl", "run", "qmail-pop3d-ssl.run",auto_uido,auto_gidq,0755);
+  C(auto_qmail,"boot/qmail-imapd-ssl", "run", "qmail-imapd-ssl.run",auto_uido,auto_gidq,0755);
+  C(auto_qmail,"boot/qmail-pbsdbd", "run", "qmail-pbsdbd.run",auto_uido,auto_gidq,0755);
+
+  /* run files for logging process */
+  l(auto_qmail,"boot/qmail/log","log/qmail",auto_userl,auto_uido,auto_gidq,0755);
+  l(auto_qmail,"boot/qmail-smtpd/log","log/qmail-smtpd",auto_userl,auto_uido,auto_gidq,0755);
+  l(auto_qmail,"boot/qmail-qmqpd/log","log/qmail-qmqpd",auto_userl,auto_uido,auto_gidq,0755);
+  l(auto_qmail,"boot/qmail-pop3d/log","log/qmail-pop3d",auto_userl,auto_uido,auto_gidq,0755);
+  l(auto_qmail,"boot/qmail-imapd-ssl/log","log/qmail-imapd-ssl",auto_userl,auto_uido,auto_gidq,0755);
+  l(auto_qmail,"boot/qmail-pop3d-ssl/log","log/qmail-pop3d-ssl",auto_userl,auto_uido,auto_gidq,0755);
+  l(auto_qmail,"boot/qmail-imapd/log","log/qmail-imapd",auto_userl,auto_uido,auto_gidq,0755);
+  l(auto_qmail,"boot/qmail-pbsdbd/log","log/qmail-pbsdbd",auto_userl,auto_uido,auto_gidq,0755);
 
   c(auto_qmail,"doc","FAQ",auto_uido,auto_gidq,0644);
   c(auto_qmail,"doc","UPGRADE",auto_uido,auto_gidq,0644);
@@ -98,6 +175,13 @@
   c(auto_qmail,"doc","PIC.relaybad",auto_uido,auto_gidq,0644);
   c(auto_qmail,"doc","PIC.relaygood",auto_uido,auto_gidq,0644);
   c(auto_qmail,"doc","PIC.rem2local",auto_uido,auto_gidq,0644);
+  c(auto_qmail,"doc","QLDAPGROUP",auto_uido,auto_gidq,0644);
+  c(auto_qmail,"doc","QLDAPINSTALL",auto_uido,auto_gidq,0644);
+  c(auto_qmail,"doc","QLDAPNEWS",auto_uido,auto_gidq,0644);
+  c(auto_qmail,"doc","QLDAPTODO",auto_uido,auto_gidq,0644);
+  c(auto_qmail,"doc","QLDAPPICTURE",auto_uido,auto_gidq,0644);
+  c(auto_qmail,"doc","EXTTODO",auto_uido,auto_gidq,0644);
+  c(auto_qmail,"doc","POPBEFORESMTP",auto_uido,auto_gidq,0644);
 
   c(auto_qmail,"bin","qmail-queue",auto_uidq,auto_gidq,04711);
   c(auto_qmail,"bin","qmail-lspawn",auto_uido,auto_gidq,0700);
@@ -108,6 +192,9 @@
   c(auto_qmail,"bin","qmail-rspawn",auto_uido,auto_gidq,0711);
   c(auto_qmail,"bin","qmail-clean",auto_uido,auto_gidq,0711);
   c(auto_qmail,"bin","qmail-send",auto_uido,auto_gidq,0711);
+#ifdef EXTERNAL_TODO
+  c(auto_qmail,"bin","qmail-todo",auto_uido,auto_gidq,0711);
+#endif
   c(auto_qmail,"bin","splogger",auto_uido,auto_gidq,0711);
   c(auto_qmail,"bin","qmail-newu",auto_uido,auto_gidq,0700);
   c(auto_qmail,"bin","qmail-newmrh",auto_uido,auto_gidq,0700);
@@ -135,6 +222,7 @@
   c(auto_qmail,"bin","forward",auto_uido,auto_gidq,0755);
   c(auto_qmail,"bin","preline",auto_uido,auto_gidq,0755);
   c(auto_qmail,"bin","condredirect",auto_uido,auto_gidq,0755);
+  c(auto_qmail,"bin","condwrite",auto_uido,auto_gidq,0755);
   c(auto_qmail,"bin","bouncesaying",auto_uido,auto_gidq,0755);
   c(auto_qmail,"bin","except",auto_uido,auto_gidq,0755);
   c(auto_qmail,"bin","maildirmake",auto_uido,auto_gidq,0755);
@@ -143,7 +231,22 @@
   c(auto_qmail,"bin","qail",auto_uido,auto_gidq,0755);
   c(auto_qmail,"bin","elq",auto_uido,auto_gidq,0755);
   c(auto_qmail,"bin","pinq",auto_uido,auto_gidq,0755);
-
+  c(auto_qmail,"bin","qmail-reply",auto_uido,auto_gidq,0755);
+  c(auto_qmail,"bin","qmail-quotawarn",auto_uido,auto_gidq,0755);
+  c(auto_qmail,"bin","auth_pop",auto_uido,auto_gidq,0700);
+  c(auto_qmail,"bin","auth_imap",auto_uido,auto_gidq,0700);
+  c(auto_qmail,"bin","auth_smtp",auto_uido,auto_gidq,0755);
+  c(auto_qmail,"bin","qmail-verify",auto_uido,auto_gidq,0755);
+  c(auto_qmail,"bin","qmail-ldaplookup",auto_uido,0,0750);
+  c(auto_qmail,"bin","qmail-cdb",auto_uido,auto_gidq,0700);
+  c(auto_qmail,"bin","digest",auto_uido,auto_gidq,0755);
+  c(auto_qmail,"bin","pbsadd",auto_uido,auto_gidq,0755);
+  c(auto_qmail,"bin","pbscheck",auto_uido,auto_gidq,0755);
+  c(auto_qmail,"bin","pbsdbd",auto_uido,auto_gidq,0755);
+  c(auto_qmail,"bin","qmail-forward",auto_uido,auto_gidq,0755);
+  c(auto_qmail,"bin","qmail-secretary",auto_uido,auto_gidq,0755);
+  c(auto_qmail,"bin","qmail-group",auto_uido,auto_gidq,0755);
+  
   c(auto_qmail,"man/man5","addresses.5",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/cat5","addresses.0",auto_uido,auto_gidq,0644);
   c(auto_qmail,"man/man5","envelopes.5",auto_uido,auto_gidq,0644);
diff -ruN qmail-1.03-orig/install.c qmail-1.03-ldap-20060201-orig/install.c
--- qmail-1.03-orig/install.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/install.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,9 +1,13 @@
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <unistd.h>
 #include "substdio.h"
 #include "strerr.h"
 #include "error.h"
 #include "open.h"
 #include "readwrite.h"
 #include "exit.h"
+#include "fifo.h"
 
 extern void hier();
 
@@ -12,7 +16,7 @@
 int fdsourcedir = -1;
 
 void h(home,uid,gid,mode)
-char *home;
+const char *home;
 int uid;
 int gid;
 int mode;
@@ -27,8 +31,8 @@
 }
 
 void d(home,subdir,uid,gid,mode)
-char *home;
-char *subdir;
+const char *home;
+const char *subdir;
 int uid;
 int gid;
 int mode;
@@ -45,8 +49,8 @@
 }
 
 void p(home,fifo,uid,gid,mode)
-char *home;
-char *fifo;
+const char *home;
+const char *fifo;
 int uid;
 int gid;
 int mode;
@@ -68,9 +72,9 @@
 substdio ssout;
 
 void c(home,subdir,file,uid,gid,mode)
-char *home;
-char *subdir;
-char *file;
+const char *home;
+const char *subdir;
+const char *file;
 int uid;
 int gid;
 int mode;
@@ -84,7 +88,7 @@
   fdin = open_read(file);
   if (fdin == -1)
     strerr_die4sys(111,FATAL,"unable to read ",file,": ");
-  substdio_fdbuf(&ssin,read,fdin,inbuf,sizeof inbuf);
+  substdio_fdbuf(&ssin,subread,fdin,inbuf,sizeof inbuf);
 
   if (chdir(home) == -1)
     strerr_die4sys(111,FATAL,"unable to switch to ",home,": ");
@@ -94,7 +98,7 @@
   fdout = open_trunc(file);
   if (fdout == -1)
     strerr_die6sys(111,FATAL,"unable to write .../",subdir,"/",file,": ");
-  substdio_fdbuf(&ssout,write,fdout,outbuf,sizeof outbuf);
+  substdio_fdbuf(&ssout,subwrite,fdout,outbuf,sizeof outbuf);
 
   switch(substdio_copy(&ssout,&ssin)) {
     case -2:
@@ -117,9 +121,123 @@
     strerr_die6sys(111,FATAL,"unable to chmod .../",subdir,"/",file,": ");
 }
 
+void C(home,subdir,file,source,uid,gid,mode)
+const char *home;
+const char *subdir;
+const char *file;
+const char *source;
+int uid;
+int gid;
+int mode;
+{
+  struct stat st;
+  int fdin;
+  int fdout;
+
+  if (fchdir(fdsourcedir) == -1)
+    strerr_die2sys(111,FATAL,"unable to switch back to source directory: ");
+
+  fdin = open_read(source);
+  if (fdin == -1)
+    strerr_die4sys(111,FATAL,"unable to read ",source,": ");
+  substdio_fdbuf(&ssin,subread,fdin,inbuf,sizeof inbuf);
+
+  if (chdir(home) == -1)
+    strerr_die4sys(111,FATAL,"unable to switch to ",home,": ");
+  if (chdir(subdir) == -1)
+    strerr_die6sys(111,FATAL,"unable to switch to ",home,"/",subdir,": ");
+
+  /* if file seems to exist don't overwrite */
+  if (stat(file, &st) == 0) {
+    close(fdin);
+    return;
+  }
+  
+  fdout = open_trunc(file);
+  if (fdout == -1)
+    strerr_die6sys(111,FATAL,"unable to write .../",subdir,"/",file,": ");
+  substdio_fdbuf(&ssout,subwrite,fdout,outbuf,sizeof outbuf);
+
+  switch(substdio_copy(&ssout,&ssin)) {
+    case -2:
+      strerr_die4sys(111,FATAL,"unable to read ",source,": ");
+    case -3:
+      strerr_die6sys(111,FATAL,"unable to write .../",subdir,"/",file,": ");
+  }
+
+  close(fdin);
+  if (substdio_flush(&ssout) == -1)
+    strerr_die6sys(111,FATAL,"unable to write .../",subdir,"/",file,": ");
+  if (fsync(fdout) == -1)
+    strerr_die6sys(111,FATAL,"unable to write .../",subdir,"/",file,": ");
+  if (close(fdout) == -1) /* NFS silliness */
+    strerr_die6sys(111,FATAL,"unable to write .../",subdir,"/",file,": ");
+
+  if (chown(file,uid,gid) == -1)
+    strerr_die6sys(111,FATAL,"unable to chown .../",subdir,"/",file,": ");
+  if (chmod(file,mode) == -1)
+    strerr_die6sys(111,FATAL,"unable to chmod .../",subdir,"/",file,": ");
+}
+
+void l(home,subdir,logdir,loguser,uid,gid,mode)
+const char *home;
+const char *subdir;
+const char *logdir;
+const char *loguser;
+int uid;
+int gid;
+int mode;
+{
+  int fdout;
+  struct stat st;
+
+  if (chdir(home) == -1)
+    strerr_die4sys(111,FATAL,"unable to switch to ",home,": ");
+  if (chdir(subdir) == -1)
+    strerr_die6sys(111,FATAL,"unable to switch to ",home,"/",subdir,": ");
+
+  /* if file seems to exist don't overwrite */
+  if (stat("run", &st) == 0) return;
+  
+  fdout = open_trunc("run");
+  if (fdout == -1)
+    strerr_die4sys(111,FATAL,"unable to write .../",subdir,"/run: ");
+  substdio_fdbuf(&ssout,subwrite,fdout,outbuf,sizeof outbuf);
+
+  /* write log script */
+  if (substdio_puts(&ssout,
+        "#!/bin/sh\n\nexec setuidgid ") == -1)
+    strerr_die4sys(111,FATAL,"unable to write .../",subdir,"/run: ");
+  if (substdio_puts(&ssout, loguser) == -1)
+    strerr_die4sys(111,FATAL,"unable to write .../",subdir,"/run: ");
+  if (substdio_puts(&ssout, " multilog t ") == -1)
+    strerr_die4sys(111,FATAL,"unable to write .../",subdir,"/run: ");
+  if (substdio_puts(&ssout, home) == -1)
+    strerr_die4sys(111,FATAL,"unable to write .../",subdir,"/run: ");
+  if (substdio_puts(&ssout, "/") == -1)
+    strerr_die4sys(111,FATAL,"unable to write .../",subdir,"/run: ");
+  if (substdio_puts(&ssout, logdir) == -1)
+    strerr_die4sys(111,FATAL,"unable to write .../",subdir,"/run: ");
+  if (substdio_puts(&ssout, "\n\n") == -1)
+    strerr_die4sys(111,FATAL,"unable to write .../",subdir,"/run: ");
+
+  if (substdio_flush(&ssout) == -1)
+    strerr_die4sys(111,FATAL,"unable to write .../",subdir,"/run: ");
+  if (fsync(fdout) == -1)
+    strerr_die4sys(111,FATAL,"unable to write .../",subdir,"/run: ");
+  if (close(fdout) == -1) /* NFS silliness */
+    strerr_die4sys(111,FATAL,"unable to write .../",subdir,"/run: ");
+
+  if (chown("run",uid,gid) == -1)
+    strerr_die4sys(111,FATAL,"unable to chown .../",subdir,"/run: ");
+  if (chmod("run",mode) == -1)
+    strerr_die4sys(111,FATAL,"unable to chmod .../",subdir,"/run: ");
+}
+
+
 void z(home,file,len,uid,gid,mode)
-char *home;
-char *file;
+const char *home;
+const char *file;
 int len;
 int uid;
 int gid;
@@ -133,7 +251,7 @@
   fdout = open_trunc(file);
   if (fdout == -1)
     strerr_die6sys(111,FATAL,"unable to write ",home,"/",file,": ");
-  substdio_fdbuf(&ssout,write,fdout,outbuf,sizeof outbuf);
+  substdio_fdbuf(&ssout,subwrite,fdout,outbuf,sizeof outbuf);
 
   while (len-- > 0)
     if (substdio_put(&ssout,"",1) == -1)
@@ -152,7 +270,7 @@
     strerr_die6sys(111,FATAL,"unable to chmod ",home,"/",file,": ");
 }
 
-void main()
+int main()
 {
   fdsourcedir = open_read(".");
   if (fdsourcedir == -1)
@@ -160,5 +278,5 @@
 
   umask(077);
   hier();
-  _exit(0);
+  return 0;
 }
